﻿using System;
using Styx.CommonBot;
using Styx.TreeSharp;
using AreaHunter.Helpers;
using System.Windows.Forms;

namespace AreaHunter
{
    class AreaHunter : BotBase
    {
        // ===========================================================
        // Constants
        // ===========================================================

        // ===========================================================
        // Fields
        // ===========================================================

        private Composite _root;

        // ===========================================================
        // Constructors
        // ===========================================================

        // ===========================================================
        // Getter & Setter
        // ===========================================================

        // ===========================================================
        // Methods for/from SuperClass/Interfaces
        // ===========================================================
        public override string Name
        {
            get
            {
                return "AreaHunter";
            }
        }

        public override PulseFlags PulseFlags
        {
            get
            {
                return PulseFlags.All;
            }
        }

        public override void Start()
        {
            try
            {
                CustomLog.Name = "AreaHunter";
                Composites.OnStart();
            }
            catch (Exception e)
            {
                CustomLog.Normal("Could not initialize.\nMessage = {0}\nStacktrace = {1}", e.Message, e.StackTrace);
            }
            finally
            {
                CustomLog.Normal("Initialization complete.");
            }
        }

        public override void Stop()
        {
            try
            {
            }
            catch (Exception e)
            {
                CustomLog.Normal("Could not dispose.\nMessage = {0}\nStacktrace = {1}", e.Message, e.StackTrace);
            }
            finally
            {
                CustomLog.Normal("Shutdown complete.");
            }
        }


        public override Composite Root
        {
            get
            {
                return _root ?? (_root = Composites.CreateRoot());
            }
        }

        public override Form ConfigurationForm
        {
            get { return new GUI.AreaHunterGUI(); }
        }
    }
}
