﻿using AreaHunter.Helpers;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace AreaHunter.GUI
{
    public partial class AreaHunterGUI : Form
    {
        public static SortedDictionary<string, int> tempBlackListedMobs;// = new SortedDictionary<string, int>();

        public AreaHunterGUI()
        {
            InitializeComponent();
            tempBlackListedMobs = Composites.BlackListedMobs;
            nsOnOffBox1.Checked = !Composites.isBlackListMode;
            nsOnOffBoxSkinMobs.Checked = Composites.doSkinning;
            ResetForm();
        }

        private void LoadList()
        {
            foreach (KeyValuePair<string, int> pair in tempBlackListedMobs)
            {
                listBoxBlackList.Items.Add(pair.Key + "-" + pair.Value.ToString());
            }
        }

        private void ResetForm()
        {
            listBoxBlackList.Items.Clear();
            TextBoxMobName.ResetText();
            TextBoxMobID.ResetText();
            LoadList();
        }


        private void ButtonAddMob_Click(object sender, EventArgs e)
        {

            string id = TextBoxMobID.Text;
            int iId = 0;
            try
            {
                iId = int.Parse(id);
            }
            catch (Exception ex)
            {
                TextBoxMobID.Text = "" + iId;
            }

            string name = TextBoxMobName.Text;
            if (name == "")
            {
                name = "" + iId;
            }

            bool isAllReadyThere = tempBlackListedMobs.ContainsKey(name);


            if (!isAllReadyThere)
            {
                tempBlackListedMobs[name] = iId;
                ResetForm();
            }
        }

        private void ButtonRemoveMob_Click(object sender, EventArgs e)
        {
            tempBlackListedMobs.Remove(TextBoxMobName.Text);
            ResetForm();
        }

        private void ButtonSaveSettings_Click(object sender, EventArgs e)
        {
            Composites.BlackListedMobs = tempBlackListedMobs;
            Composites.doSkinning = nsOnOffBoxSkinMobs.Checked;
        }

        private void ButtonCloseSettings_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void listBoxBlackList_SelectedIndexChanged(object sender, EventArgs e)
        {
            string[] values = listBoxBlackList.Items[listBoxBlackList.SelectedIndex]
                .ToString().Split('-');
            TextBoxMobName.Text = values[0];
            TextBoxMobID.Text = values[1];
        }

        private void nsOnOffBox1_CheckedChanged(object sender)
        {
            Composites.isBlackListMode = !nsOnOffBox1.Checked;
        }

        private void nsCheckBox1_CheckedChanged(object sender)
        {
            //Composites.doSkinning = nsOnOffBoxSkinMobs.Checked;
        }
    }
}
