﻿using System;
using Styx;
using Styx.WoWInternals.WoWObjects;
using System.Threading.Tasks;
using Styx.CommonBot.Coroutines;
using Styx.CommonBot.POI;

namespace AreaHunter.Helpers
{
    partial class Composites
    {

        public static async Task<bool> TargetNewEnemy()
        {
                WoWUnit unit = GetViableMob(GetAttackableMob);
                if (!StyxWoW.Me.IsFlying && !StyxWoW.Me.IsActuallyInCombat && unit != null)// && Targeting.Instance.FirstUnit != null)
                {
                    if (StyxWoW.Me.CurrentTarget != unit)
                    {
                        await CommonCoroutines.SleepForRandomUiInteractionTime();
                        unit.Target();
                    }


                    if (unit.IsDead)
                        BotPoi.Clear("Target is dead");
                    return true;
                }
            
            return false;
        }

        private static bool GetAttackableMob(WoWUnit u)
        {
            return CheckMobMeetsList(u) && u != StyxWoW.Me && u.InLineOfSight && u.IsValid && u.CanSelect && !u.IsPetBattleCritter && !u.IsTotem && !u.IsCritter && !u.IsQuestGiver && !u.IsPlayer && !u.IsPet && u.Attackable && u.IsAlive && (u.IsHostile || u.IsNeutral) && !u.TaggedByOther;
        }

        private static bool CheckMobMeetsList(WoWUnit u)
        {
            switch (isBlackListMode)
            {
                case true://blacklist mode, basically we done want the mob to be in our list if we want to attack it
                    return !(BlackListedMobs.ContainsKey(u.Name) || BlackListedMobs.ContainsValue(Convert.ToInt32(u.Entry)));//if they happen to copy the name correctly will pick that up.
                case false://whitelist mode, we can only attack these mobs 
                    return (BlackListedMobs.ContainsKey(u.Name) || BlackListedMobs.ContainsValue(Convert.ToInt32(u.Entry)));
            }
            return false;//should never reach this
        }

    }
}
