﻿using Styx;
using Styx.Common.Helpers;
using Styx.Pathing;

namespace AreaHunter.Helpers
{
    partial class Composites
    {
        private static WoWPoint _lastMoveTo;
        private static readonly WaitTimer MoveToLogTimer = WaitTimer.OneSecond;

        public static bool MoveTo(WoWPoint destination, string destinationName = null)
        {
            if (destination.DistanceSqr(_lastMoveTo) > 5 * 5)
            {
                if (MoveToLogTimer.IsFinished)
                {
                    if (string.IsNullOrEmpty(destinationName))
                        destinationName = destination.ToString();
                    CustomLog.Normal("Moving to {0}", destinationName);
                    MoveToLogTimer.Reset();
                }
                _lastMoveTo = destination;
            }
            var moveResult = Navigator.MoveTo(destination);
            return moveResult != MoveResult.Failed && moveResult != MoveResult.PathGenerationFailed;
        }

    }
}
